/*+
|                                               |
|          Procedure: ETLCUSTOFOOD              |
|                                               |
|     TIPO DE CUSTO COMO DIMENSO               |
|    Custos e planejamento para o CVI.          |
|                                               |
|            Tabelas Preenchidas:               |
|                                               |
|       1:   ETL_RESUFOOD - Produtos            |
|       2:   ETL_RESUSERV - Servios            |
|                                               |
|@C:\web_511\sql\end_conv\oracle\9350_CVISTPO_ETL_ETLCUSTOFOOD.sql
+*/


create or replace PROCEDURE ETLCUSTOFOOD(P_DTINI IN DATE,
                                         P_DTFINA IN DATE)
IS
   V_COUNTER       NUMBER       NOT NULL := 0;
   V_DTFIM         DATE;
   V_DTINI         DATE;
   V_DATAFINAL     DATE;
   V_VRCUSTPADR    FLOAT NOT NULL := 0;
   V_VRPRECVENDA   FLOAT NOT NULL := 0;
   V_ZERO          FLOAT := 0;
   V_CDSEQUENCIAL  VARCHAR2(20);
   V_CDCLIENTE     VARCHAR2(21) := NULL;
   V_MES           VARCHAR2(10);
   V_ANO           VARCHAR2(10);
   V_BIM           VARCHAR2(10);
   V_TRI           VARCHAR2(10);
   V_SEM           VARCHAR2(10);
   V_DTULTCOMEFE   DATE;
   w_C             CHAR := 'C';
   w_S             CHAR := 'S';
   w_N             CHAR := 'N';
   w_E             CHAR := 'E';
   V_TOTCUSTOPLAN  FLOAT NOT NULL := 0;
   V_TOTCUSTOREAL  FLOAT NOT NULL := 0;


BEGIN

   V_MES  :=  TO_CHAR(P_DTINI,'MM');
   V_ANO  :=  TO_CHAR(P_DTINI,'YYYY');

   DELETE FROM ETL_RESUSERV
    WHERE CDANOBI > V_ANO
      OR (CDANOBI = V_ANO AND CDMESBI >= V_MES);

   DELETE FROM ETL_RESUFOOD
    WHERE CDANOBI > V_ANO
      OR (CDANOBI = V_ANO AND CDMESBI >= V_MES);


   COMMIT;

   FOR C_NRTPCUS IN
      (SELECT TO_NUMBER(CDTIPOCUSTO) NRTIPOCUSTO, CDTIPOCUSTO as DSTIPOCUSTO
         FROM TIPOCUSTO
        WHERE IDTPCUSTOGSC = w_S
     ORDER BY NRTIPOCUSTO)
   LOOP
      V_MES  :=  TO_CHAR(P_DTINI,'MM');
      V_ANO  :=  TO_CHAR(P_DTINI,'YYYY');

      V_DTINI := ADD_MONTHS(LAST_DAY(P_DTINI) + 1, -1);

      WHILE (V_DTINI  <=  P_DTFINA) LOOP
         V_DTFIM      :=   LAST_DAY( V_DTINI);
         V_MES        :=   TO_CHAR(V_DTFIM,'MM');
         V_ANO        :=   TO_CHAR(V_DTFIM,'YYYY');
         V_BIM        :=   TO_CHAR(TRUNC((V_MES - 1) / 2) + 1);
         V_TRI        :=   TO_CHAR(TRUNC((V_MES - 1) / 3) + 1);
         V_SEM        :=   TO_CHAR(TRUNC((V_MES - 1) / 6) + 1);

         FOR C_ETL IN
            (SELECT
                    FL.CDFILIAL,        FL.CDAREAGERE,          FL.DTINICIALBI,
                    FL.CDSUPERVISOR,    FL.CDGOPERAC,           FL.CDEMPRESA,
                    FL.CDSEGMER,        P.DTPROCESSA,           P.IDCOMCUSPERC
              FROM
                    FILIAL FL, PARAMFILIAL P
              WHERE P.CDFILIAL = FL.CDFILIAL
                AND FL.IDFUNCAOFILI IS NULL
                AND FL.DTINICIALBI  IS NOT NULL
               and nvl(IDCTRLESTQ, w_S) <> w_N
               AND NVL(IDCNTRRESC, w_N) <> w_S
               ORDER BY FL.CDFILIAL
            )
         LOOP
            IF ADD_MONTHS(LAST_DAY(C_ETL.DTINICIALBI) + 1, -1) <= V_DTINI THEN

               NOVO_CODIGO('CONSPLAN'||C_ETL.CDFILIAL, V_CDSEQUENCIAL,1);
               V_CDSEQUENCIAL := SUBSTR(V_CDSEQUENCIAL,11,10);

               IF (TRUNC(C_ETL.DTPROCESSA - 1) <= TRUNC(V_DTFIM)) THEN
                  V_DATAFINAL := TRUNC(C_ETL.DTPROCESSA - 1);
               ELSE
                  V_DATAFINAL := TRUNC(V_DTFIM);
               END IF;

               CONSUMO_PLANEJADO_PLA(
                                     C_ETL.CDFILIAL,
                                     'T',
                                     V_DTINI,
                                     V_DTFIM,
                                     'T',
                                     'CFP',
                                     'N',
                                      0,
                                     'N',
                                      V_CDSEQUENCIAL,
                                     '0',
                                     'zzzzzzzzzz',
                                     '',
                                     '_'||TO_CHAR(V_DTINI, 'YYYYMMDD')||'_',
                                     '_'||TO_CHAR(V_DTFIM, 'YYYYMMDD')||'_'
                                     );

               FOR C_SERVICO IN
                  (SELECT SE.CDSERVFILI, SE.CDGRUPSERV,  SE.IDSERVPRINC,
                         SUM(DECODE(C_ETL.IDCOMCUSPERC, w_C, CA.QTCLIESTICAR, CA.QTCOMESTICAR) ) AS QTCOMESTICAR,
                         SUM(DECODE(C_ETL.IDCOMCUSPERC, w_C, CA.QTCLIEFETCAR, CA.QTCOMEFETCAR) ) AS QTCOMEFETCAR
                   FROM CARDADIA CA, SERVICO SE
                   WHERE CA.CDFILIAL = C_ETL.CDFILIAL
                     AND CA.CDFILIAL = SE.CDFILIAL
                     AND CA.CDSERVFILI = SE.CDSERVFILI
                     AND CA.DTCARDAPIO BETWEEN V_DTINI AND V_DTFIM
                   GROUP BY SE.CDSERVFILI, SE.CDGRUPSERV,  SE.IDSERVPRINC

                  ) LOOP

                  BEGIN
                     SELECT MAX(DTCARDAPIO) DTULTCOMEFE
                       INTO V_DTULTCOMEFE
                       FROM CARDADIA CA, SERVICO SE
                      WHERE CA.CDFILIAL = C_ETL.CDFILIAL
                        AND CA.CDFILIAL = SE.CDFILIAL
                        AND CA.CDSERVFILI = SE.CDSERVFILI
                        AND QTCOMEFETCAR > 0
                        AND CA.DTCARDAPIO BETWEEN V_DTINI AND V_DTFIM
                        AND SE.CDSERVFILI = C_SERVICO.CDSERVFILI
                      GROUP BY SE.CDSERVFILI;
                     EXCEPTION
                        WHEN OTHERS THEN
                           V_DTULTCOMEFE := '';
                  END;

                     BEGIN
                        SELECT VRCUSTPADR
                        INTO   V_VRCUSTPADR
                        FROM   CUSTPADR
                        WHERE  CDFILIAL     = C_ETL.CDFILIAL
                          AND  CDSERVFILI   = C_SERVICO.CDSERVFILI
                          AND  DTREFCUSPADR = V_DTINI;
                        EXCEPTION
                           WHEN OTHERS THEN
                              V_VRCUSTPADR := V_ZERO;
                     END;

                     BEGIN
                        SELECT CF.CDCLIENTE
                        INTO   V_CDCLIENTE
                        FROM   CLIENFILIAL CF, CLIENTE B
                        WHERE  CF.CDFILIAL = C_ETL.CDFILIAL
                           AND CF.CDCLIENTE = B.CDCLIENTE
                           AND CF.IDCLIENPRIN = w_S;
                        EXCEPTION
                           WHEN OTHERS THEN
                             V_CDCLIENTE := NULL;
                     END;


                     V_VRPRECVENDA := V_ZERO;
                     IF (V_CDCLIENTE IS NOT NULL) THEN BEGIN
                            SELECT MAX(VRSERVFATHIS) VRPRECOVEND
                            INTO V_VRPRECVENDA
                            FROM HISTSERVFATU
                            WHERE CDFILIAL     = C_ETL.CDFILIAL
                              AND CDSERVFILI   = C_SERVICO.CDSERVFILI
                              AND CDCLIENTE    = V_CDCLIENTE
                              AND DTSRVFATUHIS = (SELECT MAX(DTSRVFATUHIS)
                                                    FROM HISTSERVFATU
                                                   WHERE CDFILIAL     = C_ETL.CDFILIAL
                                                     AND CDCLIENTE    = V_CDCLIENTE
                                                     AND CDSERVFILI   = C_SERVICO.CDSERVFILI
                                                     AND TRUNC(DTSRVFATUHIS) <= V_DATAFINAL);
                         EXCEPTION
                            WHEN OTHERS THEN
                              V_VRPRECVENDA := V_ZERO;

                         END;
                     END IF;

                     FOR C_PRODUTO IN
                        (
                        SELECT PR.CDFILIAL, PR.CDPRODUTO,
                            SUM(PR.CUSTOPLAN) AS CUSTOPLAN,
                            SUM(PR.CUSTOREAL) AS CUSTOREAL,
                            SUM(QTCONSPLAN) AS QTCONSPLAN,
                            SUM(QTRETIRADA) AS QTRETIRADA
                        FROM
                            SERVICO SE, GRUPSERV GPS,
                            (SELECT
                               CDFILIAL, CDSERVFILI, DTCARDAPIO
                             FROM CARDADIA
                             WHERE
                                 CDFILIAL = C_ETL.CDFILIAL AND
                                (CDSERVFILI = C_SERVICO.CDSERVFILI) AND
                                (DTCARDAPIO BETWEEN V_DTINI AND V_DTFIM)
                             GROUP BY CDFILIAL, CDSERVFILI, DTCARDAPIO) CD,
                            (SELECT CDFILIAL, CDSERVFILI, DTCARDAPIO,
                               SUM(CUSTOPLAN) CUSTOPLAN,
                               SUM(CUSTOREAL) CUSTOREAL,
                               SUM(QTCONSPLAN) QTCONSPLAN,
                               SUM(QTRETIRADA) QTRETIRADA,
                               CDPRODUTO
                            FROM
                              (SELECT CP.CDFILICPLA CDFILIAL, CP.CDSERVCPLA CDSERVFILI, CP.DTCONSPLAN DTCARDAPIO,
                                  (CUSTO_PRODUTO(CP.CDFILICPLA, CP.CDPRODCPLA, C_NRTPCUS.NRTIPOCUSTO,
                                                 DECODE(PG.IDUTCARDPADR, w_S, CD.DTREFECUSTMES, CP.DTCONSPLAN),
                                                 SYSDATE) * CP.QTCONSPLAN) AS CUSTOPLAN,
                                  0 AS CUSTOREAL, CP.QTCONSPLAN, 0 AS QTRETIRADA,
                                  CP.CDPRODCPLA CDPRODUTO
                               FROM
                                  CONSPLAN CP, PARAMGERAL PG,
                                  (SELECT CD.CDFILIAL, CD.CDSERVFILI, CD.DTMESCARD, MAX(CM.DTREFECUSTMES) AS DTREFECUSTMES
                                   FROM CARDADIA CD, CARDAMES CM
                                   WHERE (CD.CDFILIAL = C_ETL.CDFILIAL)
                                     AND (CD.CDSERVFILI = C_SERVICO.CDSERVFILI)
                                     AND (CD.DTCARDAPIO BETWEEN V_DTINI AND V_DTFIM)
                                     AND (CD.CDFILIAL   = CM.CDFILIAL(+)     )
                                     AND (CD.CDSERVFILI = CM.CDSERVFILI(+)   )
                                     AND (CD.DTMESCARD  = CM.DTMESCARDAPIO(+))
                                   GROUP BY CD.CDFILIAL, CD.CDSERVFILI, CD.DTMESCARD) CD
                               WHERE
                                  (CP.CDFILICPLA   = C_ETL.CDFILIAL)   AND
                                  (CP.NRCONSPLAN   = V_CDSEQUENCIAL)   AND
                                  (CD.CDFILIAL     = CP.CDFILICPLA)    AND
                                  (CD.CDSERVFILI   = CP.CDSERVCPLA) AND
                                  (PG.CDPARGERAL   = '0001')        AND
                                  (CD.DTMESCARD    = ADD_MONTHS(LAST_DAY(CP.DTCONSPLAN) + 1, -1))
                               UNION ALL
                               SELECT CD.CDFILIAL, CD.CDSERVFILI, CD.DTCARDAPIO,
                                  DECODE(C_NRTPCUS.NRTIPOCUSTO, NULL, 0, ROUND(CNE.VRPLANNESTO * (RNE.PERATENESTO/100) * (CD.QTCOMESTICAR/H.TOTCOMEN), 5)) AS CUSTOPLAN,
                                  0 AS CUSTOREAL,
                                  CD.QTCOMESTICAR/H.TOTCOMEN AS QTCONSPLAN,
                                  0 QTRETIRADA,
                                  CNE.CDPRODUTO AS CDPRODUTO
                               FROM
                                  (SELECT
                                      DTMESCARD,  CDSERVFILI,
                                      SUM(QTCOMESTICAR) AS TOTCOMEN
                                   FROM CARDADIA
                                   WHERE
                                      (CDFILIAL = C_ETL.CDFILIAL) AND
                                      (CDSERVFILI = C_SERVICO.CDSERVFILI) AND
                                      (DTCARDAPIO BETWEEN V_DTINI AND V_DTFIM)
                                   GROUP BY DTMESCARD, CDSERVFILI
                                  ) H,
                                  CARDADIA  CD, RATENESTO RNE, CUSTNESTO CNE, DATA      DT
                               WHERE
                                  (DT.DTDATA BETWEEN V_DTINI AND V_DTFIM)                            AND
                                  (TO_CHAR(DT.DTDATA, 'MMYYYY') = TO_CHAR(CNE.DTCUSTNESTO, 'MMYYYY')) AND
                                  (CNE.CDFILIAL     = C_ETL.CDFILIAL)                                AND
                                  (RNE.CDSERVFILI = C_SERVICO.CDSERVFILI)                            AND
                                  (CNE.CDPRODUTO    = RNE.CDPRODUTO)                                  AND
                                  (CD.CDFILIAL      = RNE.CDFILIAL)                                   AND
                                  (CD.CDSERVFILI    = RNE.CDSERVFILI)                                 AND
                                  (CD.DTCARDAPIO    = DT.DTDATA)                                      AND
                                  (H.DTMESCARD      = CD.DTMESCARD)                                   AND
                                  (H.CDSERVFILI     = RNE.CDSERVFILI)                                 AND
                                  (NOT H.TOTCOMEN IS NULL AND H.TOTCOMEN <> 0)
                               UNION ALL
                               SELECT C.CDFILIAL, C.CDSERVFILI, C.DTCARDAPIO,
                                  0 CUSTOPLAN,
                                  DECODE(C_NRTPCUS.NRTIPOCUSTO, NULL, 0, (C.QTRETIRADA * CUSTO_PRODUTO(C.CDFILIAL, C.CDPRODUTO, C_NRTPCUS.NRTIPOCUSTO, C.DTCARDAPIO, SYSDATE))) AS CUSTOREAL,
                                  0 AS QTCONSPLAN,
                                  C.QTRETIRADA,
                                  C.CDPRODUTO
                               FROM
                                  (SELECT
                                     CA.CDFILIAL, CA.CDSERVFILI,CA.DTCARDAPIO,
                                     SUM(IR.QTRETIRADA * PRA.VRFATOCONV) AS QTRETIRADA,
                                     PRB.CDPRODUTO
                                  FROM CARDADIA CA, PRODUTO  PRA, PRODUTO  PRB,  ITEMRETI IR
                                  WHERE
                                     (PRB.CDPRODUTO = PRA.CDPRODESTO)                  AND
                                     (PRA.CDPRODUTO = IR.CDPRODUTO)                    AND
                                     (CA.CDFILIAL   = IR.CDFILIAL)                     AND
                                     (CA.CDFILIAL   = C_ETL.CDFILIAL )                 AND
                                     (CA.DTCARDAPIO BETWEEN V_DTINI AND V_DTFIM)   AND
                                     (CA.CDSERVFILI = C_SERVICO.CDSERVFILI)            AND
                                      (CA.NRCARDAPIO = IR.NRCARDAPIO)
                                  GROUP BY CA.CDFILIAL, CA.CDSERVFILI, CA.DTCARDAPIO, PRB.CDPRODUTO) C

                               UNION ALL
                               SELECT
                                  RNE.CDFILIAL, RNE.CDSERVFILI, DT.DTDATA      AS DTCARDAPIO,
                                  0 AS CUSTOPLAN,
                                  DECODE(C_NRTPCUS.NRTIPOCUSTO, NULL, 0, ROUND(CNE.VRREALNESTO * (RNE.PERATENESTO/100) * (CA.QTCOMEFETCAR/TC.TOTCOMEN), 5)) AS CUSTOREAL1,
                                  0 AS QTCONSPLAN,
                                  (CA.QTCOMEFETCAR/TC.TOTCOMEN),
                                  CNE.CDPRODUTO AS CDPRODUTO
                               FROM
                                  (SELECT  DTMESCARD, CDSERVFILI,
                                      SUM(QTCOMEFETCAR) AS TOTCOMEN
                                   FROM CARDADIA
                                   WHERE
                                      (CDFILIAL = C_ETL.CDFILIAL)                           AND
                                      (CDSERVFILI = C_SERVICO.CDSERVFILI)                   AND
                                      (DTCARDAPIO BETWEEN V_DTINI AND V_DTFIM)
                                   GROUP BY  DTMESCARD, CDSERVFILI
                                   ) TC, CARDADIA  CA, RATENESTO RNE, CUSTNESTO CNE,  DATA      DT
                               WHERE
                                  (DT.DTDATA BETWEEN V_DTINI AND V_DTFIM)                       AND
                                  (CNE.CDFILIAL    = C_ETL.CDFILIAL)                                 AND
                                  (TO_CHAR(DT.DTDATA, 'MMYYYY') = TO_CHAR(CNE.DTCUSTNESTO, 'MMYYYY')) AND
                                  (NOT CNE.VRREALNESTO IS NULL)                                       AND
                                  (RNE.CDFILIAL    = C_ETL.CDFILIAL)                                 AND
                                  (RNE.CDSERVFILI = C_SERVICO.CDSERVFILI)                            AND
                                  (RNE.CDPRODUTO   = CNE.CDPRODUTO)                                   AND
                                  (CA.CDFILIAL     = C_ETL.CDFILIAL)                                 AND
                                  (CA.CDSERVFILI   = RNE.CDSERVFILI)                                  AND
                                  (CA.DTCARDAPIO   = DT.DTDATA)                                       AND
                                  (TC.DTMESCARD    = CA.DTMESCARD)                                    AND
                                  (TC.CDSERVFILI   = CA.CDSERVFILI)                                   AND
                                  (NOT TC.TOTCOMEN IS NULL AND TC.TOTCOMEN <> 0)
                               UNION ALL
                               SELECT
                                  RNE.CDFILIAL, RNE.CDSERVFILI, DT.DTDATA       AS DTCARDAPIO,
                                  0 AS CUSTOPLAN,
                                  DECODE(C_NRTPCUS.NRTIPOCUSTO, NULL, 0, ROUND(TCN.VRTOTAITEM * (RNE.PERATENESTO/100) * (CA.QTCOMEFETCAR/TC.TOTCOMEN), 5)) AS CUSTOREAL1,
                                  0 AS QTCONSPLAN,
                                  (CA.QTCOMEFETCAR/TC.TOTCOMEN),
                                  TCN.CDPRODUTO CDPRODUTO
                               FROM DATA        DT, RATENESTO   RNE, CARDADIA    CA,
                                  (SELECT
                                      DTMESCARD, CDSERVFILI,
                                      SUM(QTCOMEFETCAR) AS TOTCOMEN
                                   FROM CARDADIA
                                   WHERE
                                      (CDFILIAL = C_ETL.CDFILIAL)                           AND
                                      (CDSERVFILI = C_SERVICO.CDSERVFILI)                   AND
                                      (DTCARDAPIO BETWEEN V_DTINI AND V_DTFIM)
                                   GROUP BY DTMESCARD, CDSERVFILI
                                   ) TC,
                                   (SELECT
                                       TO_CHAR(NF.DTENTRSAID, 'MMYYYY') AS DTMESNF,
                                       IP.CDPRODUTO,
                                       SUM(IP.VRTOTAITEM) AS VRTOTAITEM
                                    FROM NOTAFISCAL  NF, ITEMPRODUTO IP
                                    WHERE
                                      (IP.CDFILIAL     = NF.CDFILIAL)                       AND
                                      (IP.NRLANCTONF   = NF.NRLANCTONF)                     AND
                                      (NF.CDFILIRECE   = C_ETL.CDFILIAL)                   AND
                                      (NF.IDENTRSAIDOP = w_E)                               AND
                                      (NF.DTENTRSAID BETWEEN V_DTINI AND V_DTFIM)
                                    GROUP BY
                                       TO_CHAR(NF.DTENTRSAID, 'MMYYYY'),
                                       IP.CDPRODUTO
                                  ) TCN
                               WHERE
                                  (DT.DTDATA BETWEEN V_DTINI AND V_DTFIM)    AND
                                  (TO_CHAR(DT.DTDATA, 'MMYYYY') = TCN.DTMESNF)   AND
                                  (RNE.CDFILIAL    = C_ETL.CDFILIAL)             AND
                                  (RNE.CDSERVFILI = C_SERVICO.CDSERVFILI)        AND
                                  (CA.CDFILIAL     = C_ETL.CDFILIAL)             AND
                                  (CA.CDSERVFILI   = RNE.CDSERVFILI)             AND
                                  (CA.DTCARDAPIO   = DT.DTDATA)                  AND
                                  (CA.DTCARDAPIO   = DT.DTDATA)                  AND
                                  (TCN.CDPRODUTO   = RNE.CDPRODUTO)              AND
                                  (TC.DTMESCARD    = CA.DTMESCARD)               AND
                                  (TC.CDSERVFILI   = CA.CDSERVFILI)              AND
                                  (NOT TC.TOTCOMEN IS NULL AND TC.TOTCOMEN <> 0) AND
                                  (NOT EXISTS (SELECT CDFILIAL
                                               FROM CUSTNESTO
                                               WHERE
                                                  CDFILIAL    = C_ETL.CDFILIAL    AND
                                                  DTCUSTNESTO = DT.DTDATA          AND
                                                  CDPRODUTO   = RNE.CDPRODUTO      AND
                                                  NOT VRREALNESTO IS NULL))
                                  )
                             GROUP BY  CDFILIAL, CDSERVFILI, DTCARDAPIO, CDPRODUTO ) PR
                         WHERE
                            SE.CDFILIAL   = PR.CDFILIAL   AND
                            SE.CDSERVFILI = PR.CDSERVFILI AND
                            CD.CDFILIAL   = PR.CDFILIAL   AND
                            CD.CDSERVFILI = PR.CDSERVFILI AND
                            CD.DTCARDAPIO = PR.DTCARDAPIO AND
                            SE.CDGRUPSERV = GPS.CDGRUPSERV(+)
                         GROUP BY PR.CDFILIAL, PR.CDSERVFILI,  PR.CDPRODUTO
                         ORDER BY CDPRODUTO ) LOOP

                        INSERT INTO ETL_RESUFOOD
                           (CDFILIAL,  CDAREAGERE, CDSUPERVISOR, CDGOPERAC, CDEMPRESA, CDSEGMER,
                            CDPRODUTO, CDANOBI, CDMESBI, BIETLFOOD, TRETLFOOD, SEETLFOOD, CDGRUPSERV,
                            CDFILISERVFILI, CDTIPOCUSTO, QTETLCONPLAFOOD, QTETLRETIRAFOOD, VRETLCUSPLAFOOD,
                            VRETLCUSREAFOOD)
                        VALUES
                           (C_ETL.CDFILIAL, C_ETL.CDAREAGERE, C_ETL.CDSUPERVISOR, C_ETL.CDGOPERAC, C_ETL.CDEMPRESA,
                            C_ETL.CDSEGMER, C_PRODUTO.CDPRODUTO, V_ANO, V_MES, V_BIM, V_TRI, V_SEM, C_SERVICO.CDGRUPSERV,
                            C_ETL.CDFILIAL||C_SERVICO.CDSERVFILI, C_NRTPCUS.DSTIPOCUSTO,
                            C_PRODUTO.QTCONSPLAN, C_PRODUTO.QTRETIRADA, C_PRODUTO.CUSTOPLAN, C_PRODUTO.CUSTOREAL);

                        V_TOTCUSTOPLAN := V_TOTCUSTOPLAN + C_PRODUTO.CUSTOPLAN;
                        V_TOTCUSTOREAL := V_TOTCUSTOREAL + C_PRODUTO.CUSTOREAL;

                     END LOOP;

                     INSERT INTO ETL_RESUSERV
                        (CDFILIAL,   CDAREAGERE,  CDSUPERVISOR, CDGOPERAC,  CDEMPRESA,   CDSEGMER,
                        CDGRUPSERV, CDFILISERVFILI,  CDANOBI, CDMESBI,  BIETLSERV, TRETLSERV,
                        SEETLSERV,  CDTIPOCUSTO, QTCOMESTETLSERV,QTCOMEFEETLSERV, VRCUSPADETLSERV,
                        VRCUSVNDETLSERV, VRETLCUSPLASERV, VRETLCUSREASERV, DSDTPROCETLSERV, DSDTULTCOMEFE, DSTPSERVETLSERV)
                     VALUES
                        (C_ETL.CDFILIAL, C_ETL.CDAREAGERE, C_ETL.CDSUPERVISOR, C_ETL.CDGOPERAC, C_ETL.CDEMPRESA,
                         C_ETL.CDSEGMER, C_SERVICO.CDGRUPSERV, C_ETL.CDFILIAL||C_SERVICO.CDSERVFILI,
                         V_ANO, V_MES, V_BIM, V_TRI, V_SEM,  C_NRTPCUS.DSTIPOCUSTO, C_SERVICO.QTCOMESTICAR,
                         C_SERVICO.QTCOMEFETCAR, V_VRCUSTPADR,
                         V_VRPRECVENDA, V_TOTCUSTOPLAN, V_TOTCUSTOREAL,
                         TO_CHAR(C_ETL.DTPROCESSA, 'DD/MM/YYYY'), TO_CHAR(V_DTULTCOMEFE, 'DD/MM/YYYY'),
                         DECODE(C_SERVICO.IDSERVPRINC,'S', 'Servio Principal','Outros Servios'));
                      V_TOTCUSTOPLAN := 0;
                      V_TOTCUSTOREAL := 0;
               END LOOP;

               DELETE FROM CONSPLAN
                WHERE NRCONSPLAN = V_CDSEQUENCIAL;
               V_COUNTER := V_COUNTER + 1;
            END IF;
            IF V_COUNTER > 100 THEN
               COMMIT;
               V_COUNTER := 0;
            END IF;
         END LOOP;
         V_DTINI := ADD_MONTHS(V_DTINI,1);
      END LOOP;
      COMMIT;
   END LOOP;
END;
/


-- VERSAO --
BEGIN ATUVEROBJ('ETLCUSTOFOOD','5.011.000'); END;
/